<template>
    <div>
        <div
            class="rounded-xl bg-white shadow-lg shadow-gray-300"
            :class="{
                'h-full': bodyFullHeight,
            }"
        >
            <template
                v-if="cover"
            >
                <img
                    :src="cover"
                    class="w-full h-auto object-cover mx-auto rounded-tl-xl rounded-tr-xl"
                />
            </template>
            <template
                v-if="hasTitleSlot"
            >
                <slot name="title" />
            </template>
            <div
                v-else-if="!hasTitleSlot && title"
                class="flex text-xs leading-6"
                :class="{
                    'justify-center items-center': titleCenter
                }"
            >
                <span
                    class="font-semibold uppercase leading-tight text-ellipsis w-full mt-2 border-t border-primary border-b border-t-transparent px-4 pt-1 pb-3"
                    :class="{
                        'text-center': titleCenter,
                    }"
                >
                    {{ title }}
                </span>
            </div>
            <div
                class="text-sm leading-6 ligatures-none overflow-auto px-2 py-4"
            >
                <slot />
            </div>
        </div>
    </div>
</template>


<script setup>
import {useSlots, computed} from "vue";
import {CONFIG} from "~/config.js";

const props = defineProps({
    title: {
        required: false,
        type: [String, Number],
        default: null,
    },
    titleCenter: {
        required: false,
        type: Boolean,
        default: false,
    },
    bodyFullHeight: {
        required: false,
        type: Boolean,
        default: false,
    },
    cover: {
        required: false,
        type: String,
        default: null,
    }
});

const $slots = useSlots();
const hasTitleSlot = computed(() => {
    return $slots.title;
});
</script>
